#include <gb/gb.h>
#include <stdio.h>
#include <gb/console.h>

unsigned char SBkg0[] =
{
  0x00,0x00,0x7E,0x7E,0x42,0x42,0x42,0x42,
  0x42,0x42,0x42,0x42,0x7E,0x7E,0x00,0x00,
};

unsigned char SBkg1[] =
{
  0x00,0x00,0x00,0x00,0x3F,0x3F,0x21,0x21,
  0x21,0x21,0x21,0x21,0x21,0x21,0x3F,0x3F,
};

unsigned char SBkg2[] =
{
  0x9F,0x9F,0x00,0x00,0x00,0x00,0x9F,0x9F,
  0x90,0x90,0x90,0x90,0x90,0x90,0x90,0x90,
};

unsigned char SBkg3[] =
{
  0x48,0x48,0xCF,0xCF,0x00,0x00,0x00,0x00,
  0xCF,0xCF,0x48,0x48,0x48,0x48,0x48,0x48,
};

unsigned char SBkg4[] =
{
  0x24,0x24,0x24,0x24,0xE7,0xE7,0x00,0x00,
  0x00,0x00,0xE7,0xE7,0x24,0x24,0x24,0x24,
};

unsigned char SBkg5[] =
{
  0x12,0x12,0x12,0x12,0x12,0x12,0xF3,0xF3,
  0x00,0x00,0x00,0x00,0xF3,0xF3,0x12,0x12,
};

unsigned char SBkg6[] =
{
  0x09,0x09,0x09,0x09,0x09,0x09,0x09,0x09,
  0xF9,0xF9,0x00,0x00,0x00,0x00,0xF9,0xF9,
};

unsigned char SBkg7[] =
{
  0xFC,0xFC,0x84,0x84,0x84,0x84,0x84,0x84,
  0x84,0x84,0xFC,0xFC,0x00,0x00,0x00,0x00
};

unsigned char Spr0[] =
{
  0x18,0x18,0x66,0x66,0x5A,0x5A,0x99,0x99,
  0x99,0x99,0x5A,0x5A,0x66,0x66,0x18,0x18,
  0x18,0x18,0x66,0x66,0x4A,0x4A,0x9D,0x9D,
  0xB9,0xB9,0x52,0x52,0x66,0x66,0x18,0x18,
  0x18,0x18,0x66,0x66,0x42,0x42,0xBD,0xBD,
  0xBD,0xBD,0x42,0x42,0x66,0x66,0x18,0x18,
  0x18,0x18,0x66,0x66,0x52,0x52,0xB9,0xB9,
  0x9D,0x9D,0x4A,0x4A,0x66,0x66,0x18,0x18
};

unsigned char Spr1[] =
{
  0x7E,0x7E,0xFF,0xFF,0xE7,0xE7,0xE7,0xE7,
  0xE7,0xE7,0xE7,0xE7,0xFF,0xFF,0x7E,0x7E,
  0x7E,0x7E,0xFF,0xFF,0xF7,0xF7,0xE3,0xE3,
  0xC7,0xC7,0xEF,0xEF,0xFF,0xFF,0x7E,0x7E,
  0x7E,0x7E,0xFF,0xFF,0xFF,0xFF,0xC3,0xC3,
  0xC3,0xC3,0xFF,0xFF,0xFF,0xFF,0x7E,0x7E,
  0x7E,0x7E,0xFF,0xFF,0xEF,0xEF,0xC7,0xC7,
  0xE3,0xE3,0xF7,0xF7,0xFF,0xFF,0x7E,0x7E
};

unsigned char a0[] = { 0,0 };
unsigned char a1[] = { 1,0 };
unsigned char a2[] = { 2,0 };
unsigned char a3[] = { 3,0 };

int x[] = { 10, 20, 30, 40, 50, 60, 70, 80, 90, 100, 110, 120, 130, 140, 150, 160, 170, 180, 190, 200 };
int y[] = { 90, 90, 90, 90, 90, 90, 90, 90, 90, 90, 90, 90, 90, 90, 90, 90, 90, 90, 90, 90 };
int t[] = { 0, 5, 10, 15, 20, 25, 30, 35, 40, 45, 50, 55, 60, 65, 70, 75, 80, 85, 90, 95 };


int rval1(int tah)
{
  int jx1;

  if (tah<25) jx1=tah;
  else if ( (tah>=25) && (tah<50) ) jx1=50-tah;
  else if ( (tah>=50) && (tah<75) ) jx1=50-tah;
  else if ( (tah>=75) && (tah<100) ) jx1=tah-100;

  return jx1;
}

void do_move()
{
  int jx1;

  for (jx1=0; !(jx1>=20); jx1++)
  {
    t[jx1]++;
    if (t[jx1]>=100) t[jx1]=0;

    y[jx1]=90+(rval1(t[jx1])*2);
    x[jx1]=90+(rval1(t[(19-jx1)])*2);
  }
  
}

void main(void)
{
  int ix1=0,ix2=0,ix3,ix4=0,ix5=0;
  int x_move=0, y_move=0;
  UBYTE ch;

  set_sprite_data(0,4,Spr1);
  for (ix3=0; !(ix3>=20); ix3++)
  {
    set_sprite_tile(ix3,0);
    move_sprite(ix3,x[ix3],y[ix3]);
  }

  set_sprite_tile(20,0);
  move_sprite(20,90,90);

  SHOW_SPRITES;

  while(1)
  {
    ch=joypad();
    if (ch & J_LEFT) { x_move=x_move-3; }
    if (ch & J_RIGHT) { x_move=x_move+3; }
    if (ch & J_UP) { y_move=y_move-3; }
    if (ch & J_DOWN) { y_move=y_move+3; }
    if (ch & J_START) { x_move=0; y_move=0; }

    if (x_move<(-90)) x_move=(-90);
    if (y_move<(-90)) y_move=(-90);
    if (x_move>90) x_move=90;
    if (y_move>90) y_move=90;

    ix4++;
    if (ix4>=24) ix4=0;
    ix1=ix4/3;

    ix5++;
    if (ix5>=40) ix5=0;
    ix2=ix5/10;

    switch (ix1)
    {
      case 0 : set_bkg_data(0,1,SBkg0); break;
      case 1 : set_bkg_data(0,1,SBkg1); break;
      case 2 : set_bkg_data(0,1,SBkg2); break;
      case 3 : set_bkg_data(0,1,SBkg3); break;
      case 4 : set_bkg_data(0,1,SBkg4); break;
      case 5 : set_bkg_data(0,1,SBkg5); break;
      case 6 : set_bkg_data(0,1,SBkg6); break;
      case 7 : set_bkg_data(0,1,SBkg7); break;
      case 8 : printf("error\n"); break;
    }

    for (ix3=0; !(ix3>=21); ix3++)
    {
      switch (ix2)
      {
        case 0 : set_sprite_tile(ix3,0); break;
        case 1 : set_sprite_tile(ix3,1); break;
        case 2 : set_sprite_tile(ix3,2); break;
        case 3 : set_sprite_tile(ix3,3); break;
        case 4 : printf("error\n"); break;
      }
      move_sprite(ix3,(x[ix3]+x_move),(y[ix3]+y_move));
    }
    
    move_sprite(20,(90+x_move),(90+y_move));

   do_move(); 
   delay(2);
  }
}
